var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import cn from 'classnames';
import * as React from 'react';
import { dateFormat, offsetDays } from '../__utils/transfer';
import Button from '../button';
import Icon from '../icon';
import Layout from '../layout';
import Popup from '../popup';
import TimePicker from '../time-picker';
import Controller from './controller';
import './style/index.scss';
var AtCalendar = /** @class */ (function (_super) {
    __extends(AtCalendar, _super);
    function AtCalendar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AtCalendar.prototype.render = function () {
        return (React.createElement(Layout, { className: cn('at-calendar', { 'at-calendar--secondary': this.props.type === 'secondary' }), supportDarkMode: this.props.supportDarkMode },
            this.renderHeader(),
            this.renderBody(),
            this.renderFooter(),
            this.renderTimePicker()));
    };
    // 页头
    AtCalendar.prototype.renderHeader = function () {
        var _this = this;
        var d1 = this.state.chooseRange[0];
        var d2 = this.state.chooseRange[1];
        var t1 = this.state.timePickerTimes[0];
        var t2 = this.state.timePickerTimes[1];
        var pt2 = this.props.chooseRange ? this.props.chooseRange[1] : void 0;
        // 周n，(0~6)
        var week = new Date().getDay() - 1;
        if (week === -1) {
            week = 6;
        }
        var weeks = '一二三四五六日';
        return (React.createElement(Layout.Header, { className: "header", onCloseClick: this.props.onClose, title: this.props.title, headline: this.props.readonly, addonAfter: !this.props.readonly && (React.createElement("a", { className: cn('clear', {
                    disabled: (!t1 && !t2) ||
                        (this.props.lockRentTime && pt2 && t2 && pt2.valueOf() === t2.valueOf()),
                }), onClick: this.clearChooseRange }, this.props.lockRentTime ? '复原' : '清空')), addonBottom: React.createElement("div", { className: "addon-bottom" },
                !this.props.readonly && (React.createElement("div", { className: cn('time-range', {
                        'choose-from': !t1,
                        'choose-to': (!!t1 && !t2) || this.props.lockRentTime,
                        'choose-finished': !!t1 && !!t2 && !this.props.lockRentTime,
                    }) },
                    React.createElement("div", { className: "date from" },
                        React.createElement("h6", null, d1 ? dateFormat(d1, 'M月d日 周wk') : '取车时间'),
                        React.createElement("p", null, t1 ? dateFormat(t1, 'hh:mm') : '请设置')),
                    React.createElement("div", { className: "date to" },
                        React.createElement("h6", null, d2 ? dateFormat(d2, 'M月d日 周wk') : '还车时间'),
                        React.createElement("p", null, t2 ? dateFormat(t2, 'hh:mm') : '请设置')),
                    React.createElement("i", { className: "point" }))),
                React.createElement("ul", { className: "weeks" }, weeks.split('').map(function (w, i) { return (React.createElement("li", { key: w, className: cn({ active: _this.props.readonly && i === week }) }, w)); })),
                this.renderHeaderTips()) }));
    };
    // 主体
    AtCalendar.prototype.renderBody = function () {
        var _this = this;
        return (React.createElement(Layout.Body, { className: cn('body', { 'has-header-tips': this.state.headerTips !== '' }), id: "x-calendar-body" }, this.getMonthList().map(function (month) {
            return _this.renderMonth(month);
        })));
    };
    // 月
    AtCalendar.prototype.renderMonth = function (month) {
        var _this = this;
        var y = month.getFullYear();
        var m = month.getMonth();
        var w = month.getDay() - 1;
        if (w === -1) {
            w = 6;
        }
        var space = (function () {
            var arr = [];
            for (var i = 0; i < w; i++) {
                arr.push('');
            }
            return arr;
        })();
        var count = new Date(y, m + 1, 0).getDate();
        var list = [];
        for (var i = 0; i < count; i++) {
            list.push(new Date(y, m, i + 1));
        }
        return (React.createElement("div", { className: "month", key: month.valueOf() },
            React.createElement("h2", { className: "month-title" }, m + 1 + "\u6708"),
            React.createElement("div", { className: "list" },
                space.map(function (_, i) { return (React.createElement("span", { className: "month-day empty", key: i })); }),
                list.map(function (date) { return _this.renderMonthDay(date); }))));
    };
    // 月份的每一天
    AtCalendar.prototype.renderMonthDay = function (date) {
        var _this = this;
        var key = date.valueOf();
        var data = this.props.data && this.props.data[key] ? this.props.data[key] : { disabled: 'DISABLED' };
        var isDisabledBefore = this.props.disabledBefore ? this.props.disabledBefore > date : false;
        if (data.disabled === 'DISABLED') {
            isDisabledBefore = true;
        }
        var readonly = this.props.readonly;
        var wkname = ['sun', 'mon', 'tues', 'wed', 'thur', 'fri', 'sat'];
        var currentWk = wkname[date.getDay()];
        var isBtween = this.isBtweenChooseRange(date);
        var active = !readonly && isBtween;
        var activeFirst = !readonly && this.state.chooseRange[0] && this.state.chooseRange[0].valueOf() === key;
        var activeEnd = !readonly && this.state.chooseRange[1] && this.state.chooseRange[1].valueOf() === key;
        var css = cn('month-day', currentWk, {
            active: active,
            'active-first': activeFirst,
            'active-end': activeEnd,
            disabled: isDisabledBefore,
            'is-holiday': data.isHoliday,
            'disabled-all': !isDisabledBefore && data.disabled === 'ALL',
            'disabled-part': !isDisabledBefore && data.disabled === 'PART',
        });
        var onClick = function () {
            if ((isDisabledBefore || readonly || data.disabled) && !isBtween) {
                return;
            }
            _this.onDayClick(date, data);
        };
        // 如果提示的年月日是这天，在这天添加提示内容
        var tipsData = null;
        var startDay = this.state.chooseRange[0];
        if (this.state.chooseType !== '' && startDay) {
            this.state.chooseTipsData.forEach(function (c) {
                var d = c.day;
                if (d.getFullYear() === date.getFullYear() &&
                    d.getMonth() === date.getMonth() &&
                    d.getDate() === date.getDate()) {
                    if (c.hideAt && c.hideAt === 'never') {
                        tipsData = c;
                    }
                    if (_this.state.chooseTipsVisible && (!c.hideAt || c.hideAt === 'chooseEnd')) {
                        tipsData = c;
                    }
                }
            });
        }
        var priceTxt = '';
        if (data.price) {
            priceTxt = (data.isHoliday ? '节' : '') + "\uFFE5" + data.price;
        }
        else if (data.isHoliday) {
            priceTxt = '节假日';
        }
        return (React.createElement("div", { className: css, key: key, onClick: onClick },
            tipsData && React.createElement("div", { className: "choose-tips" }, tipsData.tips),
            React.createElement("p", null,
                React.createElement("em", null, date.getDate()),
                data.badge ? React.createElement("i", { className: "badge" }, data.badge) : null),
            React.createElement("span", null, priceTxt)));
    };
    // 头上的提示
    AtCalendar.prototype.renderHeaderTips = function () {
        var _this = this;
        if (!this.state.headerTips) {
            return null;
        }
        return (React.createElement("p", { className: cn('header-tips', { 'has-link': !!this.props.onHeaderTipsClick }), onClick: function () {
                if (_this.props.onHeaderTipsClick) {
                    _this.props.onHeaderTipsClick(_this.state.chooseRange[0], _this.state.chooseRange[1]);
                }
            } },
            this.state.headerTips,
            this.props.onHeaderTipsClick && React.createElement(Icon.Arrow, { className: "arrow" })));
    };
    // 页脚的提示
    AtCalendar.prototype.renderFooterTips = function () {
        if (this.state.footerTips) {
            return this.state.footerTips;
        }
        var min = this.props.minHours || 0;
        var times = this.state.timePickerTimes;
        var chooseOk = times[0] !== void 0 && times[1] !== void 0;
        var tips = '请选择租期';
        if (min >= 24) {
            tips = Math.round((min / 24) * 100) / 100 + "\u5929\u8D77\u79DF";
        }
        else if (min > 0) {
            tips = min + "\u5C0F\u65F6\u8D77\u79DF";
        }
        if (chooseOk) {
            return (React.createElement("p", { className: "def-tips-txt" },
                "\u5171\u8BA1",
                React.createElement("strong", null, offsetDays(times[0], times[1]))));
        }
        else {
            return React.createElement("p", { className: "def-tips-txt" }, tips);
        }
    };
    // 页脚
    AtCalendar.prototype.renderFooter = function () {
        return (React.createElement(Layout.Footer, { className: "footer", borderType: "shadow" },
            React.createElement("div", { className: "tips" },
                React.createElement("p", null,
                    React.createElement("i", null),
                    "\u5168\u5929\u53EF\u79DF"),
                React.createElement("p", null,
                    React.createElement("i", { className: "part" }),
                    "\u90E8\u5206\u65F6\u6BB5\u53EF\u79DF")),
            !this.props.readonly && (React.createElement("div", { className: "bottom" },
                React.createElement("div", { className: "footer-tips" }, this.renderFooterTips()),
                React.createElement(Button, { className: "submit", capsule: this.props.type !== 'secondary', type: this.props.type, onClick: this.onSubmit }, "\u786E\u5B9A")))));
    };
    // 时间选择器
    AtCalendar.prototype.renderTimePicker = function () {
        var _a = this.props, defaultRentTime = _a.defaultRentTime, defaultRevertTime = _a.defaultRevertTime;
        var chooseType = this.state.chooseType;
        var def = new Date(2000, 1, 1);
        if (this.state.chooseType === 'rent' && this.state.chooseRange[0]) {
            def = this.state.chooseRange[0];
        }
        else if (this.state.chooseType === 'revert' && this.state.chooseRange[1]) {
            def = this.state.chooseRange[1];
        }
        if (this.state.chooseType === 'rent' &&
            this.state.preChooseRange[0] &&
            def.valueOf() === this.state.preChooseRange[0].valueOf()) {
            def = this.state.preTimePickerTimes[0];
        }
        else if (this.state.chooseType === 'revert' &&
            this.state.preChooseRange[1] &&
            def.valueOf() === this.state.preChooseRange[1].valueOf()) {
            def = this.state.preTimePickerTimes[1];
        }
        var defaultTime = chooseType === 'revert' ? defaultRevertTime : defaultRentTime;
        return (React.createElement(Popup, { visible: this.state.timePickerVisible, noPadding: true, keepalive: false, className: cn('at-calendar__time-picker', {
                'at-calendar__time-picker--secondary': this.props.type === 'secondary',
            }), onMaskClick: this.timePickerCancel, height: "4.9rem" },
            React.createElement("header", { className: "header" },
                React.createElement("a", { className: "cancel", onClick: this.timePickerCancel }, "\u53D6\u6D88"),
                React.createElement("h2", null,
                    "\u8BF7\u9009\u62E9",
                    this.state.chooseType === 'rent' ? '取' : '还',
                    "\u8F66\u65F6\u95F4"),
                React.createElement("a", { onClick: this.timePickerNext }, "\u4E0B\u4E00\u6B65")),
            React.createElement(TimePicker, { data: [this.state.timePickerData], tips: this.state.timePickerTips, format: ['MM月dd日 周wk', 'h点', 'm分'], interval: 15, defaultDay: def, defaultTime: defaultTime, onChange: this.onTimeChange, ref: this.timePickerRef })));
    };
    return AtCalendar;
}(Controller));
export default AtCalendar;
