import * as React from 'react';
import { createPortal, render, unmountComponentAtNode } from 'react-dom';
import supportDarkMode from '../__utils/supportDarkMode';
import Spin from '../spin/index';
import './style/index.scss';
var div;
var close = function () {
    if (div && div.parentNode) {
        unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
        div = null;
    }
};
var Loading = function (params) {
    // 防止多次调用先 close 检查下
    close();
    var isReactChild = React.isValidElement(params);
    var spinType = void 0;
    div = document.createElement('div');
    div.classList.add('x-loading', 'x-loading--show');
    if (!isReactChild && params) {
        if (params.hideMask) {
            div.classList.add('x-loading--no-mask');
        }
        if (params.type) {
            spinType = params.type;
        }
    }
    if (supportDarkMode()) {
        div.classList.add('x-app--support-dark-mode');
    }
    document.body.appendChild(div);
    render(createPortal(React.createElement("div", { className: "x-loading__inner" }, isReactChild ? params : React.createElement(Spin, { type: spinType })), div), div);
    return [close, void 0];
};
Loading.hide = close;
export default Loading;
