import cn from 'classnames';
import * as React from 'react';
import './style/index.scss';
import CustomProvider from '../provider';
var isBroswer = typeof self === 'object' && self.self === self && self;
var isiOS = function (userAgent) {
    return userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
};
var isApp = function (userAgent) {
    return userAgent.indexOf('atzuche') > -1;
};
var SafeArea = function (props) {
    var context = React.useContext(CustomProvider) || {};
    var userAgent = props.userAgent || context.userAgent || (isBroswer ? window.navigator.userAgent : '');
    var composeClassName = cn("x-safe-area-inset-" + props.inset, props.className);
    if (props.inset === 'top' && isiOS(userAgent) && isApp(userAgent)) {
        composeClassName += ' x-safe-area-ios-app';
    }
    return React.createElement("div", { className: composeClassName, style: { backgroundColor: props.color } });
};
SafeArea.defaultProps = {
    color: '#ffffff',
};
export default SafeArea;
