var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var _this = this;
import React, { useEffect, useState } from 'react';
import cn from 'classnames';
import defaultRequest from './request';
import getUid from './uid';
import './style/index.scss';
var Upload = function (props) {
    var id = props.id, className = props.className, _a = props.fileList, fileList = _a === void 0 ? [] : _a, onPreview = props.onPreview, data = props.data, accept = props.accept, method = props.method, multiple = props.multiple, filename = props.filename, disabled = props.disabled, _b = props.maxCount, maxCount = _b === void 0 ? 1 : _b, onBeforeUpload = props.onBeforeUpload, onError = props.onError, onSuccess = props.onSuccess, otherProps = __rest(props, ["id", "className", "fileList", "onPreview", "data", "accept", "method", "multiple", "filename", "disabled", "maxCount", "onBeforeUpload", "onError", "onSuccess"]);
    var _c = useState(getUid()), uid = _c[0], setUid = _c[1];
    var _d = useState(false), isHideSelectEle = _d[0], setHideSelectEle = _d[1];
    var _e = useState(fileList), totalFileList = _e[0], setTotalFileList = _e[1];
    var reqs = {};
    var _f = data || {}, _g = _f.host, host = _g === void 0 ? '' : _g, _h = _f.dir, dir = _h === void 0 ? '' : _h;
    var classes = cn('x-upload', className, {
        'x-upload--disabled': disabled,
    });
    var onFileChange = function (e) {
        var _a = e.target.files, files = _a === void 0 ? [] : _a;
        var isGltMaxCount = checkFileCount(files);
        if (isGltMaxCount) {
            onError && onError(new Error('超出最大数量'));
            return;
        }
        uploadFiles(files);
        reset();
    };
    var getExtraData = function (file) {
        var _a = file.name.split('.'), name = _a[0], suffix = _a[1];
        return {
            key: "" + dir + (filename ? filename : name) + "-" + file.uid + "." + suffix,
            OSSAccessKeyId: data.accessId,
            policy: data.policy,
            Signature: data.signature,
        };
    };
    var checkFileCount = function (files) {
        // 用于提示错误，当可以多选择时一次性选择的数量+已经上传的数量超出了最大数量则提示错误
        return files.length + fileList.length > maxCount ? true : false;
    };
    var uploadFiles = function (files) {
        var originFiles = Array.prototype.slice.call(files);
        var postFiles = originFiles.map(function (file) {
            file.uid = getUid();
            return processFile(file, originFiles);
        });
        Promise.all(postFiles).then(function (fileList) { return fileList.forEach(function (file) { return post(file); }); });
    };
    var processFile = function (file, fileList) { return __awaiter(_this, void 0, void 0, function () {
        var e_1, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!onBeforeUpload) return [3 /*break*/, 4];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, onBeforeUpload(file, fileList)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    return [2 /*return*/, {
                            file: file,
                            data: null,
                            error: e_1,
                        }];
                case 4:
                    data = getExtraData(file);
                    setTotalFileList(function (f) {
                        f.push({
                            url: host + "/" + data.key,
                            uid: file.uid,
                            progress: 0,
                            done: false,
                        });
                        return f;
                    });
                    return [2 /*return*/, {
                            file: file,
                            data: data,
                        }];
            }
        });
    }); };
    var post = function (_a) {
        var file = _a.file, data = _a.data, error = _a.error;
        var uid = file.uid;
        var request = defaultRequest;
        if (!data) {
            onError && onError(error);
            return;
        }
        var requestOption = {
            action: host,
            filename: 'file',
            data: data,
            file: file,
            method: method || 'post',
            onSuccess: function () {
                onSuccess && onSuccess(updateSuccessFile(uid));
                delete reqs[uid];
            },
            onError: function (err) {
                onError && onError(err);
                delete reqs[uid];
            },
            onProgress: function (e) {
                updateFileProgress(e, uid);
            },
        };
        checkCurrentMaxCount();
        reqs[uid] = request(requestOption);
    };
    var updateSuccessFile = function (uid) {
        var currentFileIndex = totalFileList.findIndex(function (item) { return item.uid === uid; });
        if (currentFileIndex > -1) {
            var total = totalFileList.slice();
            total[currentFileIndex].done = true;
            setTotalFileList(total);
        }
        return totalFileList;
    };
    var checkCurrentMaxCount = function () {
        if (totalFileList.length >= maxCount) {
            setHideSelectEle(true);
        }
    };
    var updateFileProgress = function (e, uid) {
        var currentFileIndex = totalFileList.findIndex(function (item) { return item.uid === uid; });
        if (currentFileIndex === -1) {
            return;
        }
        var total = totalFileList.slice();
        total[currentFileIndex].progress = e.precent;
        setTotalFileList(total);
    };
    var reset = function () {
        setUid(getUid());
    };
    var abort = function (file) {
        if (file) {
            var uid_1 = file.uid ? file.uid : file;
            if (reqs[uid_1] && reqs[uid_1].abort) {
                reqs[uid_1].abort();
            }
            delete reqs[uid_1];
        }
        else {
            Object.keys(reqs).forEach(function (uid) {
                if (reqs[uid] && reqs[uid].abort) {
                    reqs[uid].abort();
                }
                delete reqs[uid];
            });
        }
    };
    var onFileItemDelete = function (uid, e) {
        e.stopPropagation();
        var currentFileIndex = totalFileList.findIndex(function (item) { return item.uid === uid; });
        if (currentFileIndex === -1) {
            return;
        }
        totalFileList.splice(currentFileIndex, 1);
        if (totalFileList.length < maxCount) {
            setHideSelectEle(false);
        }
        onSuccess && onSuccess(totalFileList);
    };
    useEffect(function () {
        return function () {
            abort();
        };
    }, []);
    if (!data || !data.host) {
        return null;
    }
    return (React.createElement("div", { className: classes },
        React.createElement("div", { className: "x-upload__inner" },
            totalFileList.map(function (file) { return (React.createElement("div", { className: "x-upload--file", key: file.uid },
                React.createElement("div", { className: "x-upload--filecontent" }, file.done && React.createElement("img", { src: file.url })),
                React.createElement("div", { className: "x-upload--handleicon", onClick: function (e) { return onFileItemDelete(file.uid, e); } }),
                file.progress !== 100 && (React.createElement("div", { className: "x-upload--progress" },
                    React.createElement("h6", null, "\u4E0A\u4F20\u4E2D"),
                    React.createElement("div", { className: "p" },
                        React.createElement("div", { className: "i", style: { width: file.progress + "% " } })))))); }),
            !isHideSelectEle && (React.createElement("div", { className: "x-upload--file x-upload--select" },
                React.createElement("input", __assign({ accept: accept, id: id, key: uid, multiple: multiple, onClick: function (e) { return e.stopPropagation(); }, type: "file", onChange: onFileChange }, otherProps)),
                React.createElement("span", null,
                    React.createElement("svg", { viewBox: "64 64 896 896", focusable: "false", "data-icon": "plus", width: "1em", height: "1em", fill: "currentColor", "aria-hidden": "true" },
                        React.createElement("path", { d: "M482 152h60q8 0 8 8v704q0 8-8 8h-60q-8 0-8-8V160q0-8 8-8z" }),
                        React.createElement("path", { d: "M176 474h672q8 0 8 8v60q0 8-8 8H176q-8 0-8-8v-60q0-8 8-8z" }))),
                React.createElement("p", null, "\u4E0A\u4F20"))))));
};
Upload.defaultProps = {
    method: 'post',
    listType: 'picture-card',
    maxCount: 1,
    fileList: [],
    multiple: false,
    accept: 'image/*',
};
export default Upload;
