import * as React from 'react';
interface IData {
    isHoliday?: boolean;
    price?: number;
    rent?: string[] | string[][];
    revert?: string[] | string[][];
    disabled?: 'ALL' | 'PART' | 'DISABLED';
    badge?: string;
}
interface IChooseTipsData {
    day: Date;
    tips: string;
    hideAt?: 'chooseEnd' | 'never';
}
interface IProps {
    readonly?: boolean;
    title?: string;
    type?: 'primary' | 'secondary';
    onClose: () => void;
    disabledBefore?: Date;
    monthRange?: [Date, Date];
    chooseRange?: [Date, Date];
    onSubmit: (start: Date, end: Date) => void;
    onDayClick?: (day: Date, type: 'rent' | 'revert') => any;
    lockRentTime?: boolean;
    checkTimeRange?: boolean | ((t1: Date, t2: Date) => React.ReactNode);
    headerTips?: (t1: Date | undefined, t2: Date | undefined) => string;
    onHeaderTipsClick?: (t1: Date | undefined, t2: Date | undefined) => void;
    footerTips?: (t1: Date | undefined, t2: Date | undefined) => string;
    data?: {
        [time: number]: IData;
    };
    minHours?: number;
    maxHours?: number;
    defaultRentTime?: string;
    defaultRevertTime?: string;
    chooseTips?: (t1: Date, t2: Date | undefined) => IChooseTipsData[] | false;
    supportDarkMode?: boolean;
}
interface IState {
    chooseRange: [Date | undefined, Date | undefined];
    preChooseRange: [Date | undefined, Date | undefined];
    timePickerVisible: boolean;
    timePickerTimes: [Date | undefined, Date | undefined];
    timePickerTips: Record<string, string>;
    preTimePickerTimes: [Date | undefined, Date | undefined];
    timePickerData: {
        day: Date;
        times?: string[] | string[][];
    };
    headerTips: string;
    footerTips: string;
    chooseType: string;
    chooseTipsData: IChooseTipsData[];
    chooseTipsVisible: boolean;
}
declare class Controller extends React.PureComponent<IProps, IState> {
    timePickerRef: React.RefObject<any>;
    constructor(props: IProps);
    replaceRange: (range: [Date, Date]) => void;
    protected checkTimeRangeCanUsed(range: [Date | undefined, Date | undefined], ignoreRange?: [Date | undefined, Date | undefined]): boolean;
    protected checkTimeRangeHasHoliday(range: [Date | undefined, Date | undefined]): boolean;
    protected getMonthList(): Date[];
    protected isBtweenChooseRange(date: Date): boolean;
    protected isBtweenRange(date: Date, range: [Date | undefined, Date | undefined]): boolean;
    protected onDayClick(day: Date, data: IData): Promise<void>;
    protected clearChooseRange: () => void;
    protected timePickerCancel: () => void;
    protected timePickerNext: () => Promise<void>;
    protected onTimeChange: () => void;
    protected onSubmit: () => void;
    private isZeroTime;
}
export default Controller;
