"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var react_router_dom_1 = require("react-router-dom");
var index_1 = __importDefault(require("../spin/index"));

var Button = function (props) {
    var type = props.type, disabled = props.disabled, shrink = props.shrink, capsule = props.capsule, mini = props.mini, lighter = props.lighter, hollow = props.hollow, shadow = props.shadow, loading = props.loading, className = props.className, children = props.children, onClick = props.onClick, to = props.to, href = props.href, otherProps = __rest(props, ["type", "disabled", "shrink", "capsule", "mini", "lighter", "hollow", "shadow", "loading", "className", "children", "onClick", "to", "href"]);
    var composeClassName = classnames_1.default('x-button', {
        'x-button--disabled': disabled,
        'x-button--loading': loading,
        'x-button--mini': mini,
        'x-button--capsule': capsule,
        'x-button--hollow': hollow,
        'x-button--lighter': type !== 'default' && lighter,
        'x-button--shrink': shrink !== void 0 ? shrink : !!mini,
        'x-button--shadow': (type === 'primary' || type === 'danger' || type === 'secondary') && !hollow && shadow,
    }, "x-button--" + (type === 'lighter' ? 'primary' : type), className);
    var content = function () { return (React.createElement(React.Fragment, null,
        !!loading && (React.createElement("div", { className: "x-button__loading" },
            React.createElement(index_1.default, null))),
        loading ? React.createElement("div", { className: "x-button__loading--opacity" }, children) : children)); };
    if (onClick) {
        var clickHandle = function (evt) {
            if (disabled || loading || !onClick) {
                return;
            }
            onClick(evt);
        };
        return (React.createElement("button", __assign({}, otherProps, { className: composeClassName, onClick: clickHandle }), content()));
    }
    if (to) {
        return (React.createElement(react_router_dom_1.Link, __assign({}, otherProps, { className: composeClassName, to: to }), content()));
    }
    if (href) {
        return (React.createElement("a", __assign({}, otherProps, { className: composeClassName, href: href }), content()));
    }
    return (React.createElement("button", __assign({}, otherProps, { className: composeClassName }), content()));
};
Button.defaultProps = {
    type: 'primary',
    capsule: true,
};
exports.default = Button;
