import * as React from 'react';

interface IRowProps {
    value?: any;
    arrow?: boolean;
    onClick?: (value?: any) => void;
    href?: string;
    to?: string;
    activable?: boolean;
    className?: string;
    children?: React.ReactNode;
    title?: string;
    addonAfter?: React.ReactNode;
    dividerIndent?: 'left' | 'both';
    [otherProps: string]: any;
}
interface ITitleProps {
    text: string;
    className?: string;
}
interface ICellProps {
    arrow?: boolean;
    dividerIndent?: 'left' | 'both';
    onClick?: (value?: any) => void;
    className?: string;
    wrapperBorder?: boolean;
    children: React.ReactNode;
    [otherProps: string]: any;
}
declare const Cell: React.FC<ICellProps> & {
    Row: React.FC<IRowProps>;
    Title: React.FC<ITitleProps>;
};
export default Cell;
