"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var react_router_dom_1 = require("react-router-dom");
var arrow_1 = __importDefault(require("../icon/arrow"));

var CellRow = function (props) {
    var value = props.value, arrow = props.arrow, onClick = props.onClick, href = props.href, to = props.to, activable = props.activable, className = props.className, children = props.children, title = props.title, dividerIndent = props.dividerIndent, indentLine = props.indentLine, endIndentLine = props.endIndentLine, addonAfter = props.addonAfter, otherProps = __rest(props, ["value", "arrow", "onClick", "href", "to", "activable", "className", "children", "title", "dividerIndent", "indentLine", "endIndentLine", "addonAfter"]);
    if (indentLine || endIndentLine) {
        // TODO: 需要废弃这两个属性
        console.warn('indentLine与endIndentLine将被废弃，请使用dividerIndent代替');
    }
    // 兼容老的属性
    // TODO: indentLine 和 endIndentLine 废弃后，该部分代码需要一起删除
    var finalDividerIndent = dividerIndent;
    if (!finalDividerIndent && (indentLine || endIndentLine)) {
        if (indentLine && !endIndentLine) {
            finalDividerIndent = 'left';
        }
        else {
            finalDividerIndent = 'both';
        }
    }
    var composeClassName = classnames_1.default('x-cell__row', className, {
        'x-cell__row--activable': onClick || to || href || activable,
        'x-cell__row--arrow': arrow,
        'x-cell__row--divider-indent-left': finalDividerIndent === 'left',
        'x-cell__row--divider-indent-both': finalDividerIndent === 'both',
    });
    var content = function () { return (React.createElement(React.Fragment, null,
        title && React.createElement("label", null, title),
        children,
        addonAfter && React.createElement("span", { className: "x-cell__addon-after" }, addonAfter),
        arrow && React.createElement(arrow_1.default, { className: "x-cell__arrow" }))); };
    if (onClick) {
        var onClickHandle = function () { return onClick(value); };
        return (React.createElement("div", __assign({}, otherProps, { className: composeClassName, onClick: onClickHandle }), content()));
    }
    if (to) {
        return (React.createElement(react_router_dom_1.Link, __assign({}, otherProps, { className: composeClassName, to: to }), content()));
    }
    if (href) {
        return (React.createElement("a", __assign({}, otherProps, { className: composeClassName, href: href }), content()));
    }
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }), content()));
};
var CellTitle = function (props) {
    var text = props.text, className = props.className, otherProps = __rest(props, ["text", "className"]);
    var composeClassName = classnames_1.default('x-cell__title', className);
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        React.createElement("h2", null, props.text)));
};
var Cell = function (props) {
    var arrow = props.arrow, indentLine = props.indentLine, endIndentLine = props.endIndentLine, dividerIndent = props.dividerIndent, className = props.className, children = props.children, onClick = props.onClick, _a = props.wrapperBorder, wrapperBorder = _a === void 0 ? true : _a, otherProps = __rest(props, ["arrow", "indentLine", "endIndentLine", "dividerIndent", "className", "children", "onClick", "wrapperBorder"]);
    if (indentLine || endIndentLine) {
        // TODO: 需要废弃这两个属性
        console.warn('indentLine与endIndentLine将被废弃，请使用dividerIndent代替');
    }
    // 兼容老的属性
    // TODO: indentLine 和 endIndentLine 废弃后，该部分代码需要一起删除
    var finalDividerIndent = dividerIndent;
    if (!finalDividerIndent && (indentLine || endIndentLine)) {
        if (indentLine && !endIndentLine) {
            finalDividerIndent = 'left';
        }
        else {
            finalDividerIndent = 'both';
        }
    }
    var composeClassName = classnames_1.default('x-cell', { 'x-cell--no-border': !wrapperBorder }, className);
    var composeChildren = React.Children.toArray(children);
    return (React.createElement("section", __assign({}, otherProps, { className: composeClassName }), composeChildren.map(function (child, index) {
        if (child && child.type === CellRow) {
            return React.cloneElement(child, {
                key: index,
                arrow: child.props.arrow === false ? false : arrow || child.props.arrow,
                onClick: child.props.href || child.props.to ? void 0 : onClick || child.props.onClick,
                dividerIndent: finalDividerIndent,
            });
        }
        return child;
    })));
};
Cell.Row = CellRow;
Cell.Title = CellTitle;
exports.default = Cell;
