"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var close_s_1 = __importDefault(require("../icon/close_s"));
var index_1 = __importDefault(require("../modal/index"));

var Dialog = /** @class */ (function (_super) {
    __extends(Dialog, _super);
    function Dialog(props) {
        var _this = _super.call(this, props) || this;
        _this.div = void 0;
        _this.div = document.createElement('div');
        _this.div.classList.add('_x_dialog_');
        document.body.appendChild(_this.div);
        return _this;
    }
    Dialog.prototype.componentWillUnmount = function () {
        if (this.div) {
            document.body.removeChild(this.div);
        }
    };
    Dialog.prototype.content = function () {
        var _a = this.props, className = _a.className, height = _a.height, visible = _a.visible, title = _a.title, _b = _a.keepalive, keepalive = _b === void 0 ? true : _b, children = _a.children, onMaskClick = _a.onMaskClick, onCloseClick = _a.onCloseClick, otherProps = __rest(_a, ["className", "height", "visible", "title", "keepalive", "children", "onMaskClick", "onCloseClick"]);
        var composeClassName = classnames_1.default('x-dialog', {
            'x-dialog--fix-top': !!onCloseClick && !title,
        }, className);
        return (React.createElement(index_1.default, __assign({}, otherProps, { visible: visible, keepalive: keepalive, height: height, onMaskClick: onMaskClick, className: composeClassName }),
            onCloseClick && (React.createElement("button", { className: "x-dialog__close", onClick: onCloseClick },
                React.createElement(close_s_1.default, null))),
            title && React.createElement("h1", { className: "x-dialog__title" }, title),
            React.createElement("div", { className: "x-dialog__inner" }, children)));
    };
    Dialog.prototype.render = function () {
        return this.div && react_dom_1.createPortal(this.content(), this.div);
    };
    return Dialog;
}(React.Component));
var Scroller = function (props) {
    var className = props.className, children = props.children, otherProps = __rest(props, ["className", "children"]);
    var composeClassName = classnames_1.default('x-dialog__scroller', className);
    return (React.createElement("div", __assign({}, otherProps, { className: composeClassName }),
        React.createElement("div", { className: "x-dialog__inscroller" }, children)));
};
Dialog.Scroller = Scroller;
exports.default = Dialog;
