"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var supportDarkMode_1 = __importDefault(require("../__utils/supportDarkMode"));
var index_1 = __importDefault(require("../spin/index"));

var div;
var close = function () {
    if (div && div.parentNode) {
        react_dom_1.unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
        div = null;
    }
};
var Loading = function (params) {
    // 防止多次调用先 close 检查下
    close();
    var isReactChild = React.isValidElement(params);
    var spinType = void 0;
    div = document.createElement('div');
    div.classList.add('x-loading', 'x-loading--show');
    if (!isReactChild && params) {
        if (params.hideMask) {
            div.classList.add('x-loading--no-mask');
        }
        if (params.type) {
            spinType = params.type;
        }
    }
    if (supportDarkMode_1.default()) {
        div.classList.add('x-app--support-dark-mode');
    }
    document.body.appendChild(div);
    react_dom_1.render(react_dom_1.createPortal(React.createElement("div", { className: "x-loading__inner" }, isReactChild ? params : React.createElement(index_1.default, { type: spinType })), div), div);
    return [close, void 0];
};
Loading.hide = close;
exports.default = Loading;
