"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var supportDarkMode_1 = __importDefault(require("../__utils/supportDarkMode"));

var close = function (id) {
    var div = document.getElementById(id);
    if (div && div.classList.contains('x-message--show')) {
        div.classList.remove('x-message--show');
        div.classList.add('x-message--hide');
        setTimeout(function () {
            if (div && div.parentNode) {
                react_dom_1.unmountComponentAtNode(div);
                div.parentNode.removeChild(div);
            }
        }, 280);
    }
};
var Message = function (params, duration) {
    if (duration === void 0) { duration = 2000; }
    var divs = document.querySelectorAll('.x-message.x-message--show');
    if (divs.length) {
        Message.close();
    }
    var div = document.createElement('div');
    div.classList.add('x-message', 'x-message--show');
    var id = "j-x-message--" + new Date().valueOf() + "-" + Math.floor(Math.random() * 999999);
    div.id = id;
    if (supportDarkMode_1.default()) {
        div.classList.add('x-app--support-dark-mode');
    }
    var layoutFooter = document.querySelector('.x-app > .x-app-footer');
    if (layoutFooter && layoutFooter.clientHeight > 0) {
        div.classList.add('x-message--behind-footer');
        layoutFooter.before(div);
    }
    else {
        document.body.appendChild(div);
    }
    var _params = { title: '' };
    if (typeof params === 'string') {
        _params.title = params;
        _params.feedback = '知道了';
        _params.onFeedbackClick = function () { return close(id); };
    }
    else {
        _params.title = params.title;
        _params.desc = params.desc;
        _params.feedback = params.feedback || '知道了';
        _params.onFeedbackClick = function () {
            params.onFeedbackClick && params.onFeedbackClick();
            close(id);
        };
    }
    react_dom_1.render(react_dom_1.createPortal(React.createElement("div", { className: "x-message__inner" },
        React.createElement("div", { className: "info" },
            React.createElement("h6", null, _params.title),
            _params.desc && React.createElement("p", null, _params.desc)),
        _params.feedback && React.createElement("button", { onClick: _params.onFeedbackClick }, _params.feedback)), div), div);
    setTimeout(close, Math.max(duration, 500), id);
};
// 清除全部message
Message.close = function () {
    var divs = document.querySelectorAll('.x-message.x-message--show');
    if (divs.length) {
        divs.forEach(function (div) { return close(div.id); });
    }
};
exports.default = Message;
