import * as React from 'react';

interface IProps {
    visible?: boolean;
    className?: string;
    onMaskClick?: () => void;
    height?: number | string;
    width?: number | string;
    addonTop?: React.ReactNode;
    addonBottom?: React.ReactNode;
    keepalive?: boolean;
}
interface IState {
    visible: boolean;
    supportDarkMode?: boolean;
    ani: 'init' | 'enter' | 'leave';
    noContent: boolean;
}
declare class Modal extends React.PureComponent<IProps, IState> {
    constructor(props: IProps);
    componentDidMount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: IProps): void;
    render(): JSX.Element;
    private enter;
    private leave;
    private onAnimationEnd;
}
export default Modal;
