"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));

var provider_1 = __importDefault(require("../provider"));
var isBroswer = typeof self === 'object' && self.self === self && self;
var isiOS = function (userAgent) {
    return userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
};
var isApp = function (userAgent) {
    return userAgent.indexOf('atzuche') > -1;
};
var SafeArea = function (props) {
    var context = React.useContext(provider_1.default) || {};
    var userAgent = props.userAgent || context.userAgent || (isBroswer ? window.navigator.userAgent : '');
    var composeClassName = classnames_1.default("x-safe-area-inset-" + props.inset, props.className);
    if (props.inset === 'top' && isiOS(userAgent) && isApp(userAgent)) {
        composeClassName += ' x-safe-area-ios-app';
    }
    return React.createElement("div", { className: composeClassName, style: { backgroundColor: props.color } });
};
SafeArea.defaultProps = {
    color: '#ffffff',
};
exports.default = SafeArea;
