"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = __importDefault(require("classnames"));
var React = __importStar(require("react"));
var check_1 = __importDefault(require("../icon/check"));
var close_1 = __importDefault(require("../icon/close"));

var Switch = function (props) {
    var i = props.i, o = props.o, active = props.active, icon = props.icon, disabled = props.disabled, _a = props.type, type = _a === void 0 ? 'primary' : _a, className = props.className, onChange = props.onChange, mini = props.mini, minimum = props.minimum, otherProps = __rest(props, ["i", "o", "active", "icon", "disabled", "type", "className", "onChange", "mini", "minimum"]);
    var composeClassName = classnames_1.default('x-switch', "x-switch--" + type, {
        'x-switch--active': active,
        'x-switch--io': !mini && i && o,
        'x-switch--disabled': disabled,
        'x-switch--mini': mini,
        'x-switch--minimum': minimum,
    }, className);
    var hasIO = !mini && !!i && !!o;
    var onClick = function () {
        if (disabled || !onChange) {
            return;
        }
        onChange(!active);
    };
    return (React.createElement("button", __assign({}, otherProps, { className: composeClassName, onClick: onClick }),
        hasIO && React.createElement("sub", null, props.i),
        hasIO && React.createElement("sup", null, props.o),
        React.createElement("em", null,
            icon && !mini && !active && React.createElement(close_1.default, null),
            icon && !mini && active && React.createElement(check_1.default, null))));
};
exports.default = Switch;
