"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_dom_1 = require("react-dom");

var timer = 0;
var div;
var close = function (callback) {
    if (div) {
        div.classList.remove('x-toast--show');
        div.classList.add('x-toast--hide');
        clearTimeout(timer);
        setTimeout(function () {
            remove();
            callback && callback();
        }, 200);
    }
};
var remove = function () {
    if (div && div.parentNode) {
        react_dom_1.unmountComponentAtNode(div);
        div.parentNode.removeChild(div);
        div = null;
    }
};
var Toast = function (text, duration, callback) {
    if (duration === void 0) { duration = 2000; }
    remove();
    div = document.createElement('div');
    div.classList.add('x-toast', 'x-toast--show');
    div.id = 'j-x-toast';
    document.body.appendChild(div);
    react_dom_1.render(react_dom_1.createPortal(React.createElement("div", { className: "x-toast__inner" },
        React.createElement("p", null, text)), div), div);
    clearTimeout(timer);
    timer = setTimeout(function () {
        close(typeof duration === 'function' ? duration : callback);
    }, Math.max(typeof duration === 'number' ? duration : 2000, 500));
};
Toast.close = close;
exports.default = Toast;
