import React from 'react';
import { AtFile } from './interface';

export interface UploadFile {
    url: string;
    uid: string;
    progress: number;
    done: boolean;
}
export interface IProps {
    id: string;
    style?: React.CSSProperties;
    accept?: string;
    action?: string;
    data: any;
    filename?: string;
    onBeforeUpload?: (file: AtFile, fileList: AtFile[]) => void;
    fileList?: UploadFile[];
    multiple?: boolean;
    maxCount?: number;
    method?: 'post' | 'get' | 'put' | 'patch';
    onPreview?: (url: string) => void;
    onProgress?: () => void;
    onSuccess: (fileList: UploadFile[]) => void;
    onError?: (error: Error) => void;
    listType?: 'picture-card';
    className?: string;
    disabled?: boolean;
}
export interface IOssData {
    accessId: string;
    policy: string;
    signature: string;
    dir: string;
    host: string;
    expire: number;
}
declare const Upload: React.FC<IProps>;
export default Upload;
